
#ifndef __HANTRO8170_H264_DECODER_H
#define __HANTRO8170_H264_DECODER_H

#include "h264decapi.h"
#include "hwdec_base_imp.h"

typedef H264DecInst H264_DEC_HANDLER;

class Hantro8170H264Decoder : public DecComponentBase
{
	public :

		Hantro8170H264Decoder();
		
		~Hantro8170H264Decoder();

		RET_STATUS DecSpecificInit();

		RET_STATUS DecSpecificPrepare();

		RET_STATUS DecSpecificDeinit();

		DEC_HANDLER DecSpecificGetHandler();

		uint32 DecSpecificGetPPMode();

		DEC_RET VideoDecode(uint8 * aData, uint32 aBusAddr, uint32 aDataLen, 
									uint8 * * outData, uint32 * outLen, uint32 * left, bool eos);

		RET_STATUS GetVideoInfo(uint32 & oFormat, uint32 & displayWidth, uint32 & displayHeight, 
									uint32 & frameWidth, uint32 & frameHeight, uint32 & interlaced);
	

	private :

		H264_DEC_HANDLER iDecHandler;
		H264DecInfo iDecHeadInfo;
		/* Decoding parameters */
		uint32 iFrameIndex;
		
};

#endif /* __ATMEL_H264_DECODER_H */

