
#ifndef __HANTRO8170_MPEG4_DECODER_H
#define __HANTRO8170_MPEG4_DECODER_H

#include "mp4decapi.h"
#include "hwdec_base_imp.h"

typedef MP4DecInst MPEG4_DEC_HANDLER;

class Hantro8170Mpeg4Decoder : public DecComponentBase
{
	public :

		Hantro8170Mpeg4Decoder();
		
		~Hantro8170Mpeg4Decoder();

		RET_STATUS DecSpecificInit();

		RET_STATUS DecSpecificPrepare();

		RET_STATUS DecSpecificDeinit();

		DEC_HANDLER DecSpecificGetHandler();

		uint32 DecSpecificGetPPMode();

		DEC_RET VideoDecode(uint8 *aData, uint32 aBusAddr, uint32 aDataLen, 
									uint8 **outData, uint32 * outLen, uint32 * left, bool eos);

		RET_STATUS GetVideoInfo(uint32 & oFormat, uint32 & displayWidth, uint32 & displayHeight, 
									uint32 & frameWidth, uint32 & frameHeight, uint32 & interlaced);
	

	private :

		MPEG4_DEC_HANDLER iDecHandler;
		MP4DecInfo iDecHeadInfo;
		/* Decoding parameters */
		uint32 iFrameIndex;
		
};

#endif /* __HANTRO8170_MPEG4_DECODER_H */

