
#ifndef __HWDEC_OS_API_H
#define __HWDEC_OS_API_H

#include <utils/Log.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>

/* This part can be modified to make it compatible with other platforms*/
#define ANDROID_MSG		1

#ifdef ANDROID_MSG
#define HWDEC_MSG(fmt,args...)						LOGI(fmt,## args)
#else
#define HWDEC_MSG(fmt,args...)						
#endif

#define HWDEC_ERR(fmt,args...)						LOGE(fmt,## args)

#define HWDEC_MALLOC(n)							malloc(n)
#define HWDEC_FREE(p)							free(p)
#define HWDEC_STR_CMP(s,d)						strcmp(s,d)
#define HWDEC_STR_LEN(s)							strlen(s)	
#define HWDEC_GET_STR_FROM_STDIN( buf , size )		fgets( buf, size , stdin)
#define HWDEC_REALLOC(p,size)						realloc(p,size)
#define HWDEC_STRN_CPY(d,s,n)					strncpy(d,s,n)
#define HWDEC_STR_STR(p,s)						strstr(p,s)
#define HWDEC_MEM_SET(p,v,n)						memset(p,v,n)
#define HWDEC_ATOI(s)							atoi(s)
#define HWDEC_MEM_CPY(d,s,n)						memcpy(d,s,n)

#define HWDEC_OPEN(d,f)							open(d,f)
#define HWDEC_CLOSE(f)							close(f)

#define HWDEC_IOCTL(a,b,c)						ioctl(a,b,c)
#define HWDEC_MMAP(a,b,c,d,e,f)					mmap(a,b,c,d,e,f)
#define HWDEC_MUNMAP(a,b)						munmap(a,b)

#ifdef FFLUSH_SUPPORT
#define HWDEC_FLUSH_CMD_BUFFER()					fflush(stdin)
#else
#define HWDEC_FLUSH_CMD_BUFFER()				\
	do{	\
		char c;	\
		while( (c = getchar()) != '\n' && c != EOF  );	\
	}while(0)
#endif

#endif /* ATMEL_OS_API_H */

