
#ifndef __LINEAR_MALLOC_H_INCLUDED
#define __LINEAR_MALLOC_H_INCLUDED

#include "basetype.h"
#include "memalloc.h"
#include "hwdec_return_codes.h"
#include "hwdec_types.h"


typedef struct
{
	uint32 *virtualAddr;
	uint32 bussAddr;
	uint32 size;
}LinearBufferCtrl;

typedef int LBUF_HANDLER;

class LinearBufferAllocator
{
	public:

		LinearBufferAllocator( uint32 numThresh , uint32 grow);

		RET_STATUS Init();
		void DeInit();
		RET_STATUS Allocate(uint32 size , LBUF_HANDLER &handler);
		void DeAllocate(LBUF_HANDLER handler);
		RET_STATUS ReAllocate(uint32 size , LBUF_HANDLER handler, bool cpy);
		uint32 getBufferSize( LBUF_HANDLER handler );
		uint8 *getBufferVirtualAddr( LBUF_HANDLER handler );
		uint32 getBufferBussAddr( LBUF_HANDLER handler);

	private:

		LinearBufferCtrl *getLinearBufferCtrlByHandler( LBUF_HANDLER handler );
		
		uint32 iBufferNum;
		uint32 iBufferNumGrow;
		uint32 iBufferNumThresh;
		
		bool initCompleted;

		int iMemAllocFd;

		LinearBufferCtrl **BufferPool;
		
};

#endif /* __LINEAR_MALLOC_H_INCLUDED */

