/*
** Copyright (C) 2009.11 Embest For AT91SAM9M10-Android2.0 camera By LiuXin- http://www.embedinfo.com/
** Copyright (C) 2009 0xlab.org - http://0xlab.org/
** Copyright 2008, The Android Open Source Project
**
** Licensed under the Apache License, Version 2.0 (the "License");
** you may not use this file except in compliance with the License.
** You may obtain a copy of the License at
**
**     http://www.apache.org/licenses/LICENSE-2.0
**
** Unless required by applicable law or agreed to in writing, software
** distributed under the License is distributed on an "AS IS" BASIS,
** WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
** See the License for the specific language governing permissions and
** limitations under the License.
*/

#ifndef _V4L2CAMERA_H
#define _V4L2CAMERA_H

#define NB_BUFFER 3				
#define DEFAULT_FRAME_RATE 15   

#include <binder/MemoryBase.h>
#include <binder/MemoryHeapBase.h>
#include <linux/videodev2.h>
#include "ccrgb16toyuv420.h"
#include "ccyuv420toyuv420semi.h"


namespace android {
struct vdIn {
    struct v4l2_capability cap;
    struct v4l2_format format;
    struct v4l2_buffer buf;
    struct v4l2_requestbuffers rb;
    void *mem[NB_BUFFER];
    bool isStreaming;
    bool isCapture;
    int width;
    int height;
    int android_width;
    int android_height;
    int formatIn;
    int framesizeIn;
};

class V4L2Camera {

public:
    V4L2Camera(); 
    ~V4L2Camera();
    int Open (int width, int height, int pixelformat, unsigned int m_preview);
    void Close (int fd);
    int Init (int fd);
    void Uninit (int fd);
    int StartStreaming (int fd);
    int StopStreaming (int fd);
    int GrabRawFrame(void *previewBuffer,int fd);
    int GrabJpegFrame (int fd);
    int readjpeg (void *previewBuffer,int fileSize);
    int savePicture(unsigned char *inputBuffer, const char * filename);
    void convert(unsigned char *buf, unsigned short *rgb, int width, int height);
    void rgb16TOyuv420(unsigned char *rgb16, unsigned char *yuv420);
private:
    struct vdIn *videoIn; 
    struct vdIn *videoIn_preview; 
    struct vdIn *videoIn_capture;
    /* RGB->YUV conversion */
       ColorConvertBase *ccRGBtoYUV;
    int fd_open;
    int fd_preview;			
    int fd_capture;
    int num;  	
    int saveYUYVtoJPEG (unsigned char *inputBuffer, int width, int height, FILE *file, int quality);

	
};

}; // namespace android

#endif
