package com.android.ethernettest;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.ServiceManager;
import android.net.server.EthernetService;
import android.net.ethernet.EthernetStateTracker;
import android.app.Notification;
import android.app.NotificationManager;


public class BootCompletedReceiver extends BroadcastReceiver {

	EthernetService mEthernetService;
	EthernetStateTracker mTrack;
	NotificationManager mNotificationManager;
	
	@Override
	public void onReceive(final Context context, Intent intent) {
		mNotificationManager = (NotificationManager)context.getSystemService("notification");
	
		mTrack = new EthernetStateTracker(context,mNotificationManager);
		mEthernetService = new EthernetService(context,mTrack);
		
		new Thread(){
			   public void run(){
				ServiceManager.addService("ETH_SERVICE", mEthernetService);
				mTrack.Init();
				mEthernetService.Init();
				
			   }
			}.start();
		
	}

}
