package com.android.ethernettest;

import android.content.Context;
import android.content.Intent;
import android.os.ServiceManager;
import android.os.IBinder;
import android.net.ethernet.IEthernetManager;
import android.net.ethernet.EthernetManager;

public class ConnectService{

	public static final String ETH_SERVICE = "ETH_SERVICE";
	
	private static EthernetManager sEthManager;
	
	public static Object getEthernetService() {
		return getEthernetManager();
	}
	
	private static EthernetManager getEthernetManager(){

		if (sEthManager == null) {
			
			IBinder b = ServiceManager.getService(ETH_SERVICE);
			IEthernetManager service = IEthernetManager.Stub.asInterface(b);
			sEthManager = new EthernetManager(service);
		}
		
		return sEthManager;
	}

}
